int carGreen24 = 13; // Verde 2 e 4
int carYellow24 = 12; // Amarelo 2 e 4
int carRed24 = 11; // Vermelho 2 e 4

int carGreen13 = 6; // Verde 1 e 3
int carYellow13 = 9; // Amarelo 1 e 3
int carRed13 = 10; // Vermelho 1 e 3

int pedGreen = 8; // Pedestre Verde
int pedRed = 7; // Pedestre Vermelho

int pedButton = 2; // Botão de Pedestres

int passTime = 4000; //Tempo Travessia Pedestre
int warningTimePed = 1000/4; //Tempo de Atenção Pedestre
int warningTimeCar = 1000; //Tempo de Atenção Carros
int trafficTime = 4000/100; //Tempo de Alternancia de Trafego

int pedFlag; //Testa se Botão de Pedestre foi Acionado

int ir13 = 4;  //IR 13
int ir24 = 3;  //IR 24

int prioIr13;
int prioIr24;

int prev;


void setup() {
pinMode(carYellow24, OUTPUT);
pinMode(carYellow13, OUTPUT);
pinMode(carGreen24, OUTPUT);
pinMode(carGreen13, OUTPUT);
pinMode(carRed24, OUTPUT);
pinMode(carRed13, OUTPUT);
pinMode(pedRed, OUTPUT);
pinMode(pedGreen, OUTPUT);
pinMode(pedButton, INPUT);

pinMode(ir13, INPUT);
pinMode(ir24, INPUT);

digitalWrite(pedGreen,LOW);
digitalWrite(pedRed,HIGH);

pedFlag = false;
}

void loop(){

  attachInterrupt(0,pedFunc,RISING);

  release13();
  prev = 13;

priority13Again:  
  for(int x=0;x<100;x++){
    prioIr13 = analogRead(ir13);
    prioIr24 = analogRead(ir24);

    if(prioIr13 > 1015 && prioIr24 < 1015){
      if(prev == 24){
        goto priority24Again;
      }
      else{
        goto priority24;
      }
    }
    else if(prev == 13 && prioIr13 < 1015 && prioIr24 > 1015){
      delay(trafficTime);
      goto priority13Again;
    }
    delay(trafficTime);
  }

priority24:
  warning13();

  pedTest();

  release24();
  prev = 24;
  
priority24Again:  
  for(int x=0;x<100;x++){
    prioIr13 = analogRead(ir13);
    prioIr24 = analogRead(ir24);
    
    if(prioIr13 < 1015 && prioIr24 > 1015){
      if(prev == 13){
        goto priority13Again;
      }
      else{
        goto priority13;
      }
    }
    else if(prev == 24 && prioIr13 > 1015 && prioIr24 < 1015){
      delay(trafficTime);
      goto priority24Again;
    }
    delay(trafficTime);
  }
  
priority13:
  warning24(); 
 
  pedTest(); 
}

void release13(){
  digitalWrite(carGreen13, HIGH);
  digitalWrite(carYellow13, LOW);
  digitalWrite(carRed13, LOW);
  digitalWrite(carGreen24, LOW);
  digitalWrite(carYellow24, LOW);
  digitalWrite(carRed24, HIGH);
}

void release24(){
  digitalWrite(carGreen13, LOW);
  digitalWrite(carYellow13, LOW);
  digitalWrite(carRed13, HIGH);
  digitalWrite(carGreen24, HIGH);
  digitalWrite(carYellow24, LOW);
  digitalWrite(carRed24, LOW);
}

void warning13(){
  digitalWrite(carGreen13, LOW);
  digitalWrite(carYellow13, HIGH);
  digitalWrite(carRed13, LOW);
  digitalWrite(carGreen24, LOW);
  digitalWrite(carYellow24, LOW);
  digitalWrite(carRed24, HIGH);
  
  delay(warningTimeCar);
}

void warning24(){
  digitalWrite(carGreen13, LOW);
  digitalWrite(carYellow13, LOW);
  digitalWrite(carRed13, HIGH);
  digitalWrite(carGreen24, LOW);
  digitalWrite(carYellow24, HIGH);
  digitalWrite(carRed24, LOW);
  
  delay(warningTimeCar);
}

void pedestres4x1(){
  digitalWrite(carRed13, HIGH);
  digitalWrite(carRed24, HIGH);
  digitalWrite(carYellow13, LOW);
  digitalWrite(carYellow24, LOW);
  digitalWrite(carGreen13, LOW);
  digitalWrite(carGreen24, LOW);
    
  digitalWrite(pedGreen,HIGH);
  digitalWrite(pedRed,LOW);
  
  delay(passTime);
  
  digitalWrite(pedGreen,LOW);
  
  for(int i=0; i<4; i++){
    digitalWrite(pedRed,LOW);
    delay(warningTimePed);
    digitalWrite(pedRed,HIGH);
    delay(warningTimePed);
  }
  pedFlag = false;
}

void pedTest(){
  if(pedFlag == true){
    pedestres4x1();
  }
}

void pedFunc(){
  pedFlag = true;
}
